#
# The Zope Irc Bot
#
# (The Stupidest Zope Product Ever Written)
#
# (C) Copyright 2000 The Internet (Aust) Pty Ltd
# ACN: 082 081 472  ABN: 83 082 081 472
# All Rights Reserved
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
# Author: Andrew Milton <akm@theinternet.com.au>


import App, Globals, OFS
import string
import time

from threading import Event

RegistryChange=Event()

from Persistence import Persistent
from Globals import ImageFile, HTMLFile, HTML, MessageDialog, package_home
from Acquisition import Implicit
from OFS.Folder import Folder
from OFS.SimpleItem import SimpleItem
from App.Extensions import getObject
from webdav.NullResource import NullResource
from ZPublisher.HTTPResponse import HTTPResponse

from IrcBot.ZopeBot import IrcBot

RegistryId='IrcRegistrar'

# The Registrar has the Registry...

class IRCRegistrar(Folder, Persistent, Implicit):
	""" A registry for IRC Bots """

	icon='misc_/IrcBot/IrcRegistrar.gif'

	index_html=manage_main=HTMLFile('registry', globals())
	
	bots={}
	def __init__(self, id='IrcRegistrar', title='IRC Bot Registrar'):
		self.id=id
		self.title=title


	def getChannel(self, channel):
		root = self
		bot=channel
		while hasattr(root, 'aq_parent'):
			root=getattr(root,'aq_parent')

		busted = 0

		for i in self.bots[bot]['PhysPath'][1:]: #[0]==''
			# Traverse the path and go force load our friends..
			try:
				root=getattr(root,i)
			except:
				# oops not there or this method doesn't work...
				print "looking for %s -- got to %s"%(bot,i)
				import traceback
				traceback.print_exc()
				
				busted=1
				break
		if not busted and root:
			return root
		print "Busted?"
		
	# We do this just to make sure the channel objects are loaded before
	# The bots start to do their thing...
	def wakeupChannels(self):
		busted=0
		for bot in self.bots.keys():
			root=self.aq_parent # go to /
			busted = 0
			for i in self.bots[bot]['PhysPath'][1:]: #[0]==''
				# Traverse the path and go force load our friends..
				try:
					root=getattr(root,i)
				except:
					# oops not there or this method doesn't work...
					print "looking for %s -- got to %s"%(bot,i)
					busted=1
					break
			if busted:
				# Can't find that bot any more -- delete it
				del self.bots[bot]
				self.bots=self.bots
				self._p_changed=1
			else:
				root.initialisePlugins()
				
	def registerIRCBot(self, id, channel):
		self.bots[id]={'URL':channel.absolute_url(),
					   'PhysPath':channel.getPhysicalPath()}
					   
		self.bots=self.bots # Let's try this instead
		self._p_changed=1		
		RegistryChange.set()

	def deregisterIRCBot(self, id):
		if self.bots.has_key(id):
			del self.bots[id]
			self.bots=self.bots # And this, since we seem to be persistently non-persistent.
			self._p_changed=1			
			RegistryChange.set()

	def getIRCBots(self):
		return self.bots

Globals.default__class_init__(IRCRegistrar)
